diff --git a/src/modules/AudioFilters/DysonCompressor.hpp b/src/modules/AudioFilters/DysonCompressor.hpp
index 2f2b086f..69409429 100644
--- a/src/modules/AudioFilters/DysonCompressor.hpp
+++ b/src/modules/AudioFilters/DysonCompressor.hpp
@@ -25,19 +25,19 @@
 #define NFILT  12
 #define NEFILT 17
 
-class DysonCompressor final : public AudioFilter
+class DysonCompressor : public AudioFilter
 {
 public:
     DysonCompressor(Module &module);
-    ~DysonCompressor();
+    ~DysonCompressor() final;
 
-    bool set() override;
+    bool set() override final;
 
 private:
-    bool setAudioParameters(uchar chn, uint srate) override;
-    int bufferedSamples() const override;
-    void clearBuffers() override;
-    double filter(Buffer &data, bool flush) override;
+    bool setAudioParameters(uchar chn, uint srate) override final;
+    int bufferedSamples() const override final;
+    void clearBuffers() override final;
+    double filter(Buffer &data, bool flush) override final;
 
     using FloatVector = QVector<float>;
 
diff --git a/src/modules/AudioFilters/Echo.hpp b/src/modules/AudioFilters/Echo.hpp
index c418ec3c..5ad34e3e 100644
--- a/src/modules/AudioFilters/Echo.hpp
+++ b/src/modules/AudioFilters/Echo.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class Echo final : public AudioFilter
+class Echo : public AudioFilter
 {
 public:
     Echo(Module &);
 
-    bool set() override;
+    bool set() override final;
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(Buffer &, bool) override;
+    bool setAudioParameters(uchar, uint) override final;
+    double filter(Buffer &, bool) override final;
 
     void alloc(bool);
 
diff --git a/src/modules/AudioFilters/Equalizer.hpp b/src/modules/AudioFilters/Equalizer.hpp
index 7c8d9665..f6b79283 100644
--- a/src/modules/AudioFilters/Equalizer.hpp
+++ b/src/modules/AudioFilters/Equalizer.hpp
@@ -23,7 +23,7 @@
 struct FFTContext;
 struct FFTComplex;
 
-class Equalizer final : public AudioFilter
+class Equalizer : public AudioFilter
 {
 public:
     static QVector<float> interpolate(const QVector<float> &, const int);
@@ -31,14 +31,14 @@ public:
     static float getAmpl(int val);
 
     Equalizer(Module &);
-    ~Equalizer();
+    ~Equalizer() final;
 
-    bool set() override;
+    bool set() override final;
 private:
-    bool setAudioParameters(uchar, uint) override;
-    int bufferedSamples() const override;
-    void clearBuffers() override;
-    double filter(Buffer &data, bool flush) override;
+    bool setAudioParameters(uchar, uint) override final;
+    int bufferedSamples() const override final;
+    void clearBuffers() override final;
+    double filter(Buffer &data, bool flush) override final;
 
     /**/
 
diff --git a/src/modules/AudioFilters/EqualizerGUI.hpp b/src/modules/AudioFilters/EqualizerGUI.hpp
index eb48d902..52aa4293 100644
--- a/src/modules/AudioFilters/EqualizerGUI.hpp
+++ b/src/modules/AudioFilters/EqualizerGUI.hpp
@@ -20,7 +20,7 @@
 
 #include <QMPlay2Extensions.hpp>
 
-class GraphW final : public QWidget
+class GraphW : public QWidget
 {
 public:
     GraphW();
@@ -31,7 +31,7 @@ public:
         values.resize(vals);
     }
 private:
-    void paintEvent(QPaintEvent *) override;
+    void paintEvent(QPaintEvent *) override final;
 
     QVector<float> values;
     float preamp;
@@ -44,15 +44,15 @@ class QCheckBox;
 class QSlider;
 class QMenu;
 
-class EqualizerGUI final : public QWidget, public QMPlay2Extensions
+class EqualizerGUI : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 public:
     EqualizerGUI(Module &);
 
-    bool set() override;
+    bool set() override final;
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget() override final;
 private slots:
     void wallpaperChanged(bool hasWallpaper, double alpha);
     void enabled(bool);
@@ -80,7 +80,7 @@ private:
 
     void loadPresets();
 
-    void showEvent(QShowEvent *event) override;
+    void showEvent(QShowEvent *event) override final;
 
     QMap<int, int> getPresetValues(const QString &name);
 
diff --git a/src/modules/AudioFilters/PhaseReverse.hpp b/src/modules/AudioFilters/PhaseReverse.hpp
index 470aad80..59fe4456 100644
--- a/src/modules/AudioFilters/PhaseReverse.hpp
+++ b/src/modules/AudioFilters/PhaseReverse.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class PhaseReverse final : public AudioFilter
+class PhaseReverse : public AudioFilter
 {
 public:
     PhaseReverse(Module &);
 
-    bool set() override;
+    bool set() override final;
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(Buffer &, bool) override;
+    bool setAudioParameters(uchar, uint) override final;
+    double filter(Buffer &, bool) override final;
 
     bool enabled, hasParameters, canFilter, reverseRight;
     uchar chn;
diff --git a/src/modules/AudioFilters/VoiceRemoval.hpp b/src/modules/AudioFilters/VoiceRemoval.hpp
index b67e6844..024c98af 100644
--- a/src/modules/AudioFilters/VoiceRemoval.hpp
+++ b/src/modules/AudioFilters/VoiceRemoval.hpp
@@ -20,15 +20,15 @@
 
 #include <AudioFilter.hpp>
 
-class VoiceRemoval final : public AudioFilter
+class VoiceRemoval : public AudioFilter
 {
 public:
     VoiceRemoval(Module &);
 
-    bool set() override;
+    bool set() override final;
 private:
-    bool setAudioParameters(uchar, uint) override;
-    double filter(Buffer &, bool) override;
+    bool setAudioParameters(uchar, uint) override final;
+    double filter(Buffer &, bool) override final;
 
     bool enabled, hasParameters, canFilter;
     uchar chn;
diff --git a/src/modules/Extensions/CMakeLists.txt b/src/modules/Extensions/CMakeLists.txt
index 9be7afeb..9263b6f1 100644
--- a/src/modules/Extensions/CMakeLists.txt
+++ b/src/modules/Extensions/CMakeLists.txt
@@ -55,7 +55,11 @@ if(USE_MEDIABROWSER)
     set(QML Qt5::Qml)
 endif()
 
-qt5_wrap_ui(Extensions_FORM_HDR ${Extensions_FORMS})
+if(USE_QT4)
+    qt4_wrap_ui(Extensions_FORM_HDR ${Extensions_FORMS})
+else()
+    qt5_wrap_ui(Extensions_FORM_HDR ${Extensions_FORMS})
+endif()
 set_property(SOURCE ${Extensions_FORM_HDR} PROPERTY SKIP_AUTOMOC ON)
 
 include_directories(../../qmplay2/headers
@@ -69,9 +73,15 @@ add_library(${PROJECT_NAME} ${QMPLAY2_MODULE}
     ${Extensions_RESOURCES}
 )
 
+if(USE_QT4)
+    add_definitions(-I@prefix@/include/QJson4)
+    target_link_libraries(${PROJECT_NAME} Qt4::QtCore Qt4::QtGui QJson4)
+else()
+    target_link_libraries(${PROJECT_NAME} ${QML})
+endif()
+
 target_link_libraries(${PROJECT_NAME}
     ${DBUS}
-    ${QML}
     libqmplay2
 )
 
diff --git a/src/modules/Extensions/Downloader.cpp b/src/modules/Extensions/Downloader.cpp
index 78f30efe..0160b026 100644
--- a/src/modules/Extensions/Downloader.cpp
+++ b/src/modules/Extensions/Downloader.cpp
@@ -29,8 +29,6 @@
 #include <QTimer>
 #include <QLabel>
 #include <QAction>
-#include <QScreen>
-#include <QWindow>
 #include <QProcess>
 #include <QMimeData>
 #include <QClipboard>
@@ -46,14 +44,10 @@
 #include <QProgressBar>
 #include <QApplication>
 #include <QElapsedTimer>
-#include <QStandardPaths>
-#include <QLoggingCategory>
 #include <QDialogButtonBox>
 
 #include <functional>
 
-Q_LOGGING_CATEGORY(downloader, "Downloader")
-
 /**/
 
 constexpr const char *g_defaultMp3ConvertCommand = "ffmpeg -i <input/> -vn -sn -c:a libmp3lame -ab 224k -f mp3 -y <output>%f.mp3</output>";
@@ -358,7 +352,7 @@ void DownloadItemW::downloadStop(bool ok)
     finished = true;
     if (!dontDeleteDownloadThr)
     {
-        if (visibleRegion().isNull())
+        if (visibleRegion().isEmpty())
             emit QMPlay2Core.sendMessage(titleL->text(), sizeL->text());
     }
 }
@@ -368,30 +362,12 @@ void DownloadItemW::startConversion()
     deleteConvertProcess();
 
     m_convertProcess = new QProcess(this);
-    m_convertProcessConn[0] = connect(m_convertProcess, Overload<int>::of(&QProcess::finished), this, [this](int exitCode) {
-        if (exitCode == 0)
-        {
-            sizeL->setText(tr(g_downloadComplete));
-            QFile::remove(filePath);
-            m_needsConversion = false;
-            filePath = m_convertedFilePath;
-            downloadStop(true);
-        }
-        else
-        {
-            sizeL->setText(tr(g_conversionError));
-            qCWarning(downloader) << "Failed to convert:" << m_convertProcess->program() << m_convertProcess->arguments() << m_convertProcess->readAllStandardError().constData();
-            downloadStop(false);
-        }
-    });
-    m_convertProcessConn[1] = connect(m_convertProcess, &QProcess::errorOccurred, this, [this](QProcess::ProcessError error) {
-        if (error == QProcess::FailedToStart)
-        {
-            sizeL->setText(tr(g_conversionError));
-            downloadStop(false);
-            qCWarning(downloader) << "Failed to start process:" << m_convertProcess->program();
-        }
-    });
+
+    // Use old-style connect for Qt4 compatibility
+    connect(m_convertProcess, SIGNAL(finished(int, QProcess::ExitStatus)),
+            this, SLOT(handleConversionFinished(int, QProcess::ExitStatus)));
+    connect(m_convertProcess, SIGNAL(error(QProcess::ProcessError)),
+            this, SLOT(handleConversionError(QProcess::ProcessError)));
 
     m_needsConversion = true;
     finished = false;
@@ -404,7 +380,7 @@ void DownloadItemW::startConversion()
     const auto conversionError = [&](const QString &errStr) {
         sizeL->setText(tr(g_conversionError));
         downloadStop(false);
-        qCWarning(downloader).noquote() << errStr;
+        qWarning() << errStr;
     };
 
     QString convertCommand;
@@ -448,21 +424,63 @@ void DownloadItemW::startConversion()
     convertCommand.replace(idx1, idx2 - idx1 + 9, "\"" + m_convertedFilePath + "\"");
     maybeAddAbsolutePath(convertCommand);
 
-    qDebug() << "Starting conversion:" << convertCommand.toUtf8().constData();
-    m_convertProcess->start(convertCommand);
+    // Store program name and arguments for Qt4 compatibility
+    m_processProgram = convertCommand.section(' ', 0, 0); // Extract the program name
+    m_processArguments = convertCommand.split(' ').mid(1); // Extract the arguments (everything after the program name)
+
+    qDebug() << "Starting conversion:" << m_processProgram << m_processArguments;
+
+    // Start the process using the program name and arguments
+    m_convertProcess->start(m_processProgram, m_processArguments);
 }
+
 void DownloadItemW::deleteConvertProcess()
 {
     if (m_convertProcess)
     {
-        disconnect(m_convertProcessConn[0]);
-        disconnect(m_convertProcessConn[1]);
+        disconnect(m_convertProcess, SIGNAL(finished(int)), this, SLOT(yourSlotForFinished(int)));
+        disconnect(m_convertProcess, SIGNAL(errorOccurred(QProcess::ProcessError)), this, SLOT(yourSlotForError(QProcess::ProcessError)));
         m_convertProcess->close();
         delete m_convertProcess;
         m_convertProcess = nullptr;
     }
 }
 
+void DownloadItemW::handleConversionFinished(int exitCode, QProcess::ExitStatus)
+{
+    if (exitCode == 0) // Conversion succeeded
+    {
+        sizeL->setText(tr(g_downloadComplete));
+        QFile::remove(filePath);
+        m_needsConversion = false;
+        filePath = m_convertedFilePath;
+        downloadStop(true);
+    }
+    else // Conversion failed
+    {
+        sizeL->setText(tr(g_conversionError));
+
+        // Manually log the program and arguments stored during the process start
+        qWarning() << "Failed to convert: Program - " << m_processProgram
+                   << " Arguments - " << m_processArguments.join(" ")
+                   << " Error - " << m_convertProcess->readAllStandardError().constData();
+
+        downloadStop(false);
+    }
+}
+
+void DownloadItemW::handleConversionError(QProcess::ProcessError error)
+{
+    if (error == QProcess::FailedToStart)
+    {
+        sizeL->setText(tr(g_conversionError));
+        downloadStop(false);
+
+        // Manually log the program name stored earlier
+        qWarning() << "Failed to start process: Program - " << m_processProgram;
+    }
+}
+
 /**/
 
 DownloaderThread::DownloaderThread(QDataStream *stream, const QString &url, DownloadListW *downloadLW, const QMenu *convertsMenu, const QString &name, const QString &prefix, const QString &param, const QString &preset) :
@@ -843,7 +861,7 @@ void Downloader::init()
     connect(downloadLW, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(itemDoubleClicked(QTreeWidgetItem *)));
 
     m_convertsMenu = new QMenu(this);
-    connect(m_convertsMenu->addAction(tr("&Add")), &QAction::triggered, this, &Downloader::addConvertPreset);
+    connect(m_convertsMenu->addAction(tr("&Add")), SIGNAL(triggered()), this, SLOT(addConvertPreset()));
     m_convertsMenu->addSeparator();
 
     setDownloadsDirB = new QToolButton;
@@ -879,7 +897,7 @@ void Downloader::init()
     layout->addItem(new QSpacerItem(10, 0, QSizePolicy::Fixed, QSizePolicy::Minimum), 1, 4, 1, 1);
     layout->addWidget(m_convertsPresetsB, 1, 5, 1, 1);
 
-    QString defDownloadPath = QStandardPaths::standardLocations(QStandardPaths::DownloadLocation).value(0, QDir::homePath()) + "/";
+    QString defDownloadPath = QDir::homePath() + "/";
 #ifdef Q_OS_WIN
     defDownloadPath.replace('\\', '/');
 #endif
@@ -930,7 +948,7 @@ void Downloader::init()
         const auto createPreset = [this](const QString &name, const QString &data) {
             QAction *act = m_convertsMenu->addAction(name);
             act->setData(data);
-            connect(act, &QAction::triggered, this, &Downloader::editConvertAction);
+            connect(act, SIGNAL(triggered()), this, SLOT(editConvertAction()));
             return act;
         };
 
@@ -976,7 +994,7 @@ QVector<QAction *> Downloader::getActions(const QString &name, double, const QSt
     const auto createAction = [&](const QString &actionName, const QString &preset) {
         QAction *act = new QAction(actionName, nullptr);
         act->setIcon(QIcon(":/downloader.svgz"));
-        act->connect(act, &QAction::triggered, this, &Downloader::download);
+        act->connect(act, SIGNAL(triggered()), this, SLOT(download()));
         act->setProperty("name", name);
         if (!prefix.isEmpty())
         {
@@ -1009,15 +1027,17 @@ void Downloader::addConvertPreset()
     QAction *action = m_convertsMenu->addAction("MP3 224k");
     action->setData(g_defaultMp3ConvertCommand);
     if (modifyConvertAction(action, false))
-        connect(action, &QAction::triggered, this, &Downloader::editConvertAction);
+        connect(action, SIGNAL(triggered()), this, SLOT(editConvertAction()));
     else
         action->deleteLater();
 }
+
 void Downloader::editConvertAction()
 {
     if (QAction *action = qobject_cast<QAction *>(sender()))
         modifyConvertAction(action);
 }
+
 bool Downloader::modifyConvertAction(QAction *action, bool addRemoveButton)
 {
     QDialog dialog(this);
@@ -1026,83 +1046,60 @@ bool Downloader::modifyConvertAction(QAction *action, bool addRemoveButton)
     QLineEdit *nameE = new QLineEdit(action->text());
     QLineEdit *commandE = new QLineEdit(action->data().toString());
 
-    commandE->setToolTip(tr("Command line to execute after download.\n\n<input/> - specifies downloaded file.\n<output>%f.mp3</output> - converted file will be input file with \"mp3\" extension."));
-
     QDialogButtonBox *buttons = new QDialogButtonBox(QDialogButtonBox::Ok | QDialogButtonBox::Cancel);
-    connect(buttons, &QDialogButtonBox::accepted, &dialog, &QDialog::accept);
-    connect(buttons, &QDialogButtonBox::rejected, &dialog, &QDialog::reject);
+    connect(buttons, SIGNAL(accepted()), &dialog, SLOT(accept()));
+    connect(buttons, SIGNAL(rejected()), &dialog, SLOT(reject()));
+
+    QPushButton *removeB = nullptr;
     if (addRemoveButton)
     {
-        QPushButton *removeB = buttons->addButton(tr("Remove"), QDialogButtonBox::DestructiveRole);
+        removeB = buttons->addButton(tr("Remove"), QDialogButtonBox::DestructiveRole);
         removeB->setIcon(QMPlay2Core.getIconFromTheme("list-remove"));
-        connect(buttons, &QDialogButtonBox::clicked, &dialog, [&](QAbstractButton *button) {
-            if (button == removeB)
-            {
-                action->deleteLater();
-                dialog.reject();
-            }
-        });
+
+        // Store the button, action, and dialog in member variables for later access
+        currentAction = action;
+        currentDialog = &dialog;
+
+        // Connect the remove button to the slot
+        connect(removeB, SIGNAL(clicked()), this, SLOT(handleRemoveButtonClicked()));
     }
 
     QFormLayout *layout = new QFormLayout(&dialog);
-    layout->setMargin(4);
-    layout->setSpacing(4);
     layout->addRow(tr("Preset name"), nameE);
     layout->addRow(tr("Command line"), commandE);
     layout->addRow(buttons);
 
-    if (QWindow *win = window()->windowHandle())
+    if (dialog.exec() == QDialog::Accepted)
     {
-        if (QScreen *screen = win->screen())
-            dialog.resize(screen->availableGeometry().width() / 2, 1);
+        action->setText(nameE->text().simplified());
+        action->setData(commandE->text().trimmed());
+        return true;
     }
-
-    while (dialog.exec() == QDialog::Accepted)
+    else if (removeB && dialog.result() == QDialogButtonBox::DestructiveRole)
     {
-        const QString name = nameE->text().simplified();
-        const QString command = commandE->text();
-
-        if (name.isEmpty() || !command.contains(' '))
-        {
-            QMessageBox::warning(this, dialog.windowTitle(), tr("Incorrect/empty name or command line!"));
-            continue;
-        }
-
-        if (!command.contains("<input/>"))
-        {
-            QMessageBox::warning(this, dialog.windowTitle(), tr("Command must contain <input/> tag!"));
-            continue;
-        }
-        if (getCommandOutput(command).isEmpty())
-        {
-            QMessageBox::warning(this, dialog.windowTitle(), tr("Command must contain correct <output>file</output/> tag!"));
-            continue;
-        }
-
-        const QList<QAction *> actions = m_convertsMenu->actions();
-        bool ok = true;
-        for (int i = 1; i < actions.count(); ++i) // Skip first "Add" action
-        {
-            if (actions[i] != action && actions[i]->text().compare(name, Qt::CaseInsensitive) == 0)
-            {
-                ok = false;
-                break;
-            }
-        }
-
-        if (!ok)
-        {
-            QMessageBox::warning(this, dialog.windowTitle(), tr("Preset name already exists!"));
-            continue;
-        }
+        action->deleteLater();
+        return false;
+    }
 
-        action->setText(name);
-        action->setData(command.trimmed());
+    return false;
+}
 
-        return true;
+void Downloader::handleButtonClicked(QAbstractButton *button)
+{
+    if (button == removeB && currentAction && currentDialog) // Ensure valid pointers
+    {
+        currentAction->deleteLater();
+        currentDialog->reject();
     }
+}
 
-    return false;
+void Downloader::handleRemoveButtonClicked()
+{
+    if (removeB && currentAction && currentDialog)  // Ensure valid pointers
+    {
+        currentAction->deleteLater();
+        currentDialog->reject();
+    }
 }
 
 void Downloader::setDownloadsDir()
@@ -1120,6 +1117,7 @@ void Downloader::setDownloadsDir()
     else if (dir.filePath() != QString())
         QMessageBox::warning(this, DownloaderName, tr("Cannot change downloading files directory"));
 }
+
 void Downloader::clearFinished()
 {
     const QList<QTreeWidgetItem *> items = downloadLW->findItems(QString(), Qt::MatchContains);
@@ -1127,6 +1125,7 @@ void Downloader::clearFinished()
         if (((DownloadItemW *)downloadLW->itemWidget(items[i], 0))->isFinished())
             delete items[i];
 }
+
 void Downloader::addUrl()
 {
     QString clipboardUrl;
@@ -1141,6 +1140,7 @@ void Downloader::addUrl()
     if (!url.isEmpty())
         new DownloaderThread(nullptr, url, downloadLW, m_convertsMenu);
 }
+
 void Downloader::download()
 {
     QAction *action = qobject_cast<QAction *>(sender());
@@ -1158,6 +1158,7 @@ void Downloader::download()
     );
     downloadLW->setCurrentItem(downloadLW->invisibleRootItem()->child(0));
 }
+
 void Downloader::itemDoubleClicked(QTreeWidgetItem *item)
 {
     DownloadItemW *downloadItemW = (DownloadItemW *)downloadLW->itemWidget(item, 0);
diff --git a/src/modules/Extensions/Downloader.hpp b/src/modules/Extensions/Downloader.hpp
index a19787ac..c14ce2ac 100644
--- a/src/modules/Extensions/Downloader.hpp
+++ b/src/modules/Extensions/Downloader.hpp
@@ -21,9 +21,12 @@
 #include <QMPlay2Extensions.hpp>
 #include <IOController.hpp>
 
+#include <QProcess>
 #include <QTreeWidget>
 #include <QToolButton>
 #include <QThread>
+#include <QWidget>
+#include <QPushButton>
 
 class QLabel;
 class QProcess;
@@ -32,11 +35,11 @@ class QProgressBar;
 class QTreeWidgetItem;
 class DownloaderThread;
 
-class DownloadItemW final : public QWidget
+class DownloadItemW : public QWidget
 {
     Q_OBJECT
 public:
-    DownloadItemW(DownloaderThread *downloaderThr, QString name, const QIcon &icon, QDataStream *stream, QString preset);
+    explicit DownloadItemW(DownloaderThread *downloaderThr, QString name, const QIcon &icon, QDataStream *stream, QString preset);
     ~DownloadItemW();
 
     void setName(const QString &);
@@ -69,6 +72,8 @@ signals:
     void stop();
 private slots:
     void toggleStartStop();
+    void handleConversionFinished(int exitCode, QProcess::ExitStatus);
+    void handleConversionError(QProcess::ProcessError);
 private:
     void downloadStop(bool);
 
@@ -89,8 +94,10 @@ private:
         QProgressBar *progressB;
     } *speedProgressW = nullptr;
 
-    QProcess *m_convertProcess = nullptr;
-    QMetaObject::Connection m_convertProcessConn[2];
+    QString m_processProgram;      // To store the program name
+    QStringList m_processArguments; // To store the process arguments
+    QProcess *m_convertProcess; // QProcess is now fully included
+    int m_convertProcessConn[2]; // Replace QMetaObject::Connection with int
     bool finished, readyToPlay, m_needsConversion = false;
     QString m_convertPreset;
     QString filePath;
@@ -99,7 +106,7 @@ private:
 
 /**/
 
-class DownloadListW final : public QTreeWidget
+class DownloadListW : public QTreeWidget
 {
     friend class Downloader;
 public:
@@ -113,13 +120,13 @@ private:
 
 /**/
 
-class DownloaderThread final : public QThread
+class DownloaderThread : public QThread
 {
     Q_OBJECT
     enum {ADD_ENTRY, NAME, SET, SET_POS, SET_SPEED, DOWNLOAD_ERROR, FINISH};
 public:
     DownloaderThread(QDataStream *stream, const QString &url, DownloadListW *downloadLW, const QMenu *convertsMenu, const QString &name = QString(), const QString &prefix = QString(), const QString &param = QString(), const QString &preset = QString());
-    ~DownloaderThread();
+    ~DownloaderThread() final;
 
     void serialize(QDataStream &stream);
 
@@ -131,7 +138,7 @@ private slots:
     void stop();
     void finished();
 private:
-    void run() override;
+    void run() override final;
 
     QIcon getIcon();
 
@@ -145,19 +152,19 @@ private:
 
 /**/
 
-class Downloader final : public QWidget, public QMPlay2Extensions
+class Downloader : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
 public:
     Downloader(Module &module);
-    ~Downloader();
+    ~Downloader() final;
 
-    void init() override;
+    void init() override final;
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget() override final;
 
-    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override;
+    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override final;
 
 private:
     void addConvertPreset();
@@ -170,6 +177,8 @@ private slots:
     void addUrl();
     void download();
     void itemDoubleClicked(QTreeWidgetItem *);
+    void handleButtonClicked(QAbstractButton *button);
+    void handleRemoveButtonClicked();
 
 private:
     Settings m_sets;
@@ -182,6 +191,10 @@ private:
 
     QToolButton *m_convertsPresetsB;
     QMenu *m_convertsMenu;
+
+    QAction *currentAction;      // Pointer to the current action being modified
+    QDialog *currentDialog;      // Pointer to the current dialog being used
+    QPushButton *removeB; 
 };
 
 #define DownloaderName "QMPlay2 Downloader"
diff --git a/src/modules/Extensions/Extensions.cpp b/src/modules/Extensions/Extensions.cpp
index e4f8f9be..e2b4a8d1 100644
--- a/src/modules/Extensions/Extensions.cpp
+++ b/src/modules/Extensions/Extensions.cpp
@@ -150,17 +150,31 @@ ModuleSettingsWidget::ModuleSettingsWidget(Module &module) :
     subtitlesB->setToolTip(tr("Displays subtitles from YouTube. Follows default subtitles language and QMPlay2 language."));
     subtitlesB->setChecked(sets().getBool("YouTube/Subtitles"));
 
+    int idx;
+
+    m_preferredCodec = new QComboBox;
+    m_preferredCodec->setSizePolicy(QSizePolicy(QSizePolicy::Expanding, QSizePolicy::Preferred));
+    m_preferredCodec->addItems({"VP9", "H.264", "AV1"}); // Must match "PreferredCodec" enum
+    idx = m_preferredCodec->findText(sets().getString("YouTube/PreferredCodec"));
+    m_preferredCodec->setCurrentIndex(idx > -1 ? idx : 0);
+
     qualityPreset = new QComboBox;
     qualityPreset->setSizePolicy(QSizePolicy(QSizePolicy::Expanding, QSizePolicy::Preferred));
     qualityPreset->addItems(YouTube::getQualityPresets());
-    int idx = qualityPreset->findText(sets().getString("YouTube/QualityPreset"));
+    idx = qualityPreset->findText(sets().getString("YouTube/QualityPreset"));
     qualityPreset->setCurrentIndex(idx > -1 ? idx : 3);
 
+    m_allowVp9Hdr = new QCheckBox(tr("Allow HDR content for VP9 codec"));
+    m_allowVp9Hdr->setChecked(sets().getBool("YouTube/AllowVp9HDR"));
+
     layout = new QGridLayout(youTubeB);
     layout->addWidget(userNameB, 0, 0, 1, 2);
     layout->addWidget(subtitlesB, 1, 0, 1, 2);
-    layout->addWidget(new QLabel(tr("Preferred quality") + ": "), 2, 0, 1, 1);
-    layout->addWidget(qualityPreset, 2, 1, 1, 1);
+    layout->addWidget(new QLabel(tr("Preferred video codec") + ": "), 2, 0, 1, 1);
+    layout->addWidget(m_preferredCodec, 2, 1, 1, 1);
+    layout->addWidget(new QLabel(tr("Preferred quality") + ": "), 3, 0, 1, 1);
+    layout->addWidget(qualityPreset, 3, 1, 1, 1);
+    layout->addWidget(m_allowVp9Hdr, 4, 0, 1, 2);
     layout->setMargin(2);
 
 #ifdef USE_LASTFM
@@ -233,6 +247,8 @@ void ModuleSettingsWidget::saveSettings()
     sets().set("YouTube/ShowUserName", userNameB->isChecked());
     sets().set("YouTube/Subtitles", subtitlesB->isChecked());
     sets().set("YouTube/QualityPreset", qualityPreset->currentText());
+    sets().set("YouTube/PreferredCodec", m_preferredCodec->currentText());
+    sets().set("YouTube/AllowVp9HDR", m_allowVp9Hdr->isChecked());
 
 #ifdef USE_LASTFM
     sets().set("LastFM/DownloadCovers", downloadCoversGB->isChecked());
diff --git a/src/modules/Extensions/Extensions.hpp b/src/modules/Extensions/Extensions.hpp
index c2a424e1..07d6c163 100644
--- a/src/modules/Extensions/Extensions.hpp
+++ b/src/modules/Extensions/Extensions.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class Extensions final : public Module
+class Extensions : public Module
 {
 public:
     Extensions();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 
     QIcon downloader, youtube, radio;
 #ifdef USE_LASTFM
@@ -45,7 +45,7 @@ class QGroupBox;
 class QCheckBox;
 class LineEdit;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
 public:
@@ -56,14 +56,15 @@ private slots:
     void passwordEdited();
 #endif
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
 #ifdef USE_MPRIS2
     QCheckBox *MPRIS2B;
 #endif
 
     QCheckBox *userNameB, *subtitlesB;
-    QComboBox *qualityPreset;
+    QComboBox *m_preferredCodec, *qualityPreset;
+    QCheckBox *m_allowVp9Hdr;
 
 #ifdef USE_LASTFM
     QGroupBox *downloadCoversGB;
